include \masm32\include\masm32rt.inc

.data?
hDll	dd ?
rectCaller	RECT <?>
pUseA	dd ?
pUseB	dd ?

.code
start:
	mov hDll, rv(LoadLibrary, chr$("Struct_Dll"))	; rv is the retval macro ([url=\masm32\macros\macros.asm#"rv macro"]source[/url]), which returns eax
	.if eax
		mov pUseA, rv(GetProcAddress, hDll, chr$("GetTheRectA"))
		.if eax
			push offset rectCaller	; we use a global structure for method A
			call pUseA
			xchg ebx, eax			; move the pointer to the structure into a protected register
			print "Desktop width and height, method A: "
			print str$([ebx.RECT.right]), "/"
			print str$([ebx.RECT.bottom]), 13, 10
		.else
			invoke MessageBox, 0, chr$("GetTheRectA not found"), 0, MB_OK
		.endif
		mov pUseB, rv(GetProcAddress, hDll, chr$("GetTheRectB"))
		.if eax
			call pUseB
			mov eax, offset rectCaller
			print "Desktop width and height, method B: "
			print str$([rectCaller.right]), "/"
			print str$([rectCaller.bottom])
		.else
			invoke MessageBox, 0, chr$("GetTheRectB not found"), 0, MB_OK
		.endif
		invoke FreeLibrary, hDll
	.else
		invoke MessageBox, 0, chr$("DLL not found"), 0, MB_OK
	.endif
	exit

end start

OPT_Tmp2Asm	1
